#!/bin/sh


INSTALL=0
UNINSTALL=0
START=0
STOP=0
TURN=""

while [[ $# > 0 ]]
do
key="$1"
shift

case $key in
    -i|--install)
    INSTALL=1
    ;;
    -u|--uninstall)
    UNINSTALL=1
    ;;
    -s|--start)
    START=1
    ;;
    -p|--stop)
    STOP=1
    ;;
    -t|--turn)
    TURN="$1"
    shift
    ;;    
    *)
            # unknown option
    ;;
esac
done


if [ $INSTALL -eq 1 ]; then

	echo install
	if [ -e "$PWD/nf_ddd_udp.ko" ]; then
	
		DST_DIR=/usr/lib/modules/$(uname -r)/kernel/net/ipv4/netfilter/
	
		if [ -d "$DST_DIR" ]; then
			yes | cp -fi nf_ddd_udp.ko "$DST_DIR"
		fi
		
		DST_DIR=/lib/modules/$(uname -r)/kernel/net/ipv4/netfilter/
	
		if [ -d "$DST_DIR" ]; then
			yes | cp -fi nf_ddd_udp.ko "$DST_DIR"
		fi
	fi
fi

if [ $UNINSTALL -eq 1 ]; then

	echo uninstall

	MODULE_FILE=/usr/lib/modules/$(uname -r)/kernel/net/ipv4/netfilter/nf_ddd_udp.ko
	
	if [ -e "$MODULE_FILE" ]; then
		rm -f "$MODULE_FILE"
	fi
	
	MODULE_FILE=/lib/modules/$(uname -r)/kernel/net/ipv4/netfilter/nf_ddd_udp.ko
	
	if [ -e "$MODULE_FILE" ]; then
		rm -f "$MODULE_FILE"
	fi
fi

if [ $START -eq 1 ]; then

	echo start
	modprobe -r nf_ddd_udp
	modprobe nf_ddd_udp
fi

if [ $STOP -eq 1 ]; then

	echo stop
	modprobe -r nf_ddd_udp
fi

if [ "$TURN" == "on" ]; then

	echo turn on
	echo 0 > /proc/sys/net/ipv4/ddd_udp/0/ddd_udp
	echo bond0 > /proc/sys/net/ipv4/ddd_udp/0/ddd_udp_ifname
	echo 60000 > /proc/sys/net/ipv4/ddd_udp/0/ddd_peer_ttl
	echo 1000 > /proc/sys/net/ipv4/ddd_udp/0/ddd_packet_ttl
	echo 128 > /proc/sys/net/ipv4/ddd_udp/0/ddd_cache_max
	echo 8 > /proc/sys/net/ipv4/ddd_udp/0/ddd_history_max
	echo 1 > /proc/sys/net/ipv4/ddd_udp/0/ddd_udp
fi

if [ "$TURN" == "off" ]; then
	echo turn off
	echo 0 > /proc/sys/net/ipv4/ddd_udp/0/ddd_udp
fi
